Index: branches/VNS/HeuristicLab.Algorithms.LocalSearch/3.3/HeuristicLab.Algorithms.LocalSearch-3.3.csproj
===================================================================
--- branches/VNS/HeuristicLab.Algorithms.LocalSearch/3.3/HeuristicLab.Algorithms.LocalSearch-3.3.csproj	(revision 5642)
+++ branches/VNS/HeuristicLab.Algorithms.LocalSearch/3.3/HeuristicLab.Algorithms.LocalSearch-3.3.csproj	(revision 5735)
@@ -108,5 +108,5 @@
   <ItemGroup>
     <Compile Include="HeuristicLabAlgorithmsLocalSearchPlugin.cs" />
-    <Compile Include="LocalSearchImprovement.cs" />
+    <Compile Include="LocalSearchImprovementOperator.cs" />
     <Compile Include="LocalSearchMainLoop.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
Index: branches/VNS/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearchImprovement.cs
===================================================================
--- branches/VNS/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearchImprovement.cs	(revision 5642)
+++ 	(revision )
@@ -1,284 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Operators;
-using HeuristicLab.Common;
-using HeuristicLab.Parameters;
-using HeuristicLab.Algorithms.LocalSearch;
-using HeuristicLab.Data;
-using HeuristicLab.Optimization;
-using HeuristicLab.Optimization.Operators;
-
-namespace HeuristicLab.Algorithms.LocalSearch {
-  /// <summary>
-  /// A local search improvement operator.
-  /// </summary>
-  [Item("LocalSearchImprovement", "A local search improvement operator.")]
-  [StorableClass]
-  public class LocalSearchImprovement: SingleSuccessorOperator, ILocalImprovement {
-    [Storable]
-    private LocalSearchMainLoop loop;
-    
-    private ConstrainedValueParameter<IMoveGenerator> MoveGeneratorParameter {
-      get { return (ConstrainedValueParameter<IMoveGenerator>)Parameters["MoveGenerator"]; }
-    }
-    private ConstrainedValueParameter<IMoveMaker> MoveMakerParameter {
-      get { return (ConstrainedValueParameter<IMoveMaker>)Parameters["MoveMaker"]; }
-    }
-    private ConstrainedValueParameter<ISingleObjectiveMoveEvaluator> MoveEvaluatorParameter {
-      get { return (ConstrainedValueParameter<ISingleObjectiveMoveEvaluator>)Parameters["MoveEvaluator"]; }
-    }
-    private ValueParameter<IntValue> MaximumIterationsParameter {
-      get { return (ValueParameter<IntValue>)Parameters["MaximumIterations"]; }
-    }
-    private ValueParameter<IntValue> SampleSizeParameter {
-      get { return (ValueParameter<IntValue>)Parameters["SampleSize"]; }
-    }
-    public LookupParameter<IntValue> EvaluatedSolutionsParameter {
-      get { return (LookupParameter<IntValue>)Parameters["EvaluatedSolutions"]; }
-    }
-    public LookupParameter<IOperator> AnalyzerParameter {
-      get { return (LookupParameter<IOperator>)Parameters["Analyzer"]; }
-    }
-
-    public IMoveGenerator MoveGenerator {
-      get { return MoveGeneratorParameter.Value; }
-      set { MoveGeneratorParameter.Value = value; }
-    }
-    public IMoveMaker MoveMaker {
-      get { return MoveMakerParameter.Value; }
-      set { MoveMakerParameter.Value = value; }
-    }
-    public ISingleObjectiveMoveEvaluator MoveEvaluator {
-      get { return MoveEvaluatorParameter.Value; }
-      set { MoveEvaluatorParameter.Value = value; }
-    }
-
-    [StorableConstructor]
-    protected LocalSearchImprovement(bool deserializing) : base(deserializing) {}
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-      Initialize();
-    }
-    protected LocalSearchImprovement(LocalSearchImprovement original, Cloner cloner)
-      : base(original, cloner) {
-        this.loop = cloner.Clone(original.loop);
-        Initialize();
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new LocalSearchImprovement(this, cloner);
-    }
-    public LocalSearchImprovement()
-      : base() {
-        loop = new LocalSearchMainLoop(new BoolValue(true));
-
-        Parameters.Add(new ConstrainedValueParameter<IMoveGenerator>("MoveGenerator", "The operator used to generate moves to the neighborhood of the current solution."));
-        Parameters.Add(new ConstrainedValueParameter<IMoveMaker>("MoveMaker", "The operator used to perform a move."));
-        Parameters.Add(new ConstrainedValueParameter<ISingleObjectiveMoveEvaluator>("MoveEvaluator", "The operator used to evaluate a move."));
-        Parameters.Add(new ValueParameter<IntValue>("MaximumIterations", "The maximum number of generations which should be processed.", new IntValue(1000)));
-        Parameters.Add(new ValueParameter<IntValue>("SampleSize", "Number of moves that MultiMoveGenerators should create. This is ignored for Exhaustive- and SingleMoveGenerators.", new IntValue(100)));
-        Parameters.Add(new LookupParameter<IntValue>("EvaluatedSolutions", "The number of evaluated moves."));
-        Parameters.Add(new LookupParameter<IOperator>("Analyzer", "The operator used to analyze the solution."));
-
-        Initialize();
-    }
-
-    private void Initialize() {
-      MoveGeneratorParameter.ValueChanged += new EventHandler(MoveGeneratorParameter_ValueChanged);
-    }
-
-    public void Parameterize(IProblem problem) {
-      UpdateMoveOperators(problem);
-      ChooseMoveOperators();
-
-      ParameterizeMoveGenerators(problem as ISingleObjectiveProblem);
-      ParameterizeMoveEvaluators(problem as ISingleObjectiveProblem);
-      ParameterizeMoveMakers(problem as ISingleObjectiveProblem);
-    }
-
-    void MoveGeneratorParameter_ValueChanged(object sender, EventArgs e) {
-      ChooseMoveOperators();
-    }
-
-    private void UpdateMoveOperators(IProblem problem) {
-      IMoveGenerator oldMoveGenerator = MoveGenerator;
-      IMoveMaker oldMoveMaker = MoveMaker;
-      ISingleObjectiveMoveEvaluator oldMoveEvaluator = MoveEvaluator;
-
-      ClearMoveParameters();
-
-      if (problem != null) {
-        foreach (IMoveGenerator generator in problem.Operators.OfType<IMoveGenerator>().OrderBy(x => x.Name))
-          MoveGeneratorParameter.ValidValues.Add(generator);
-
-        foreach (IMoveMaker maker in problem.Operators.OfType<IMoveMaker>().OrderBy(x => x.Name))
-          MoveMakerParameter.ValidValues.Add(maker);
-
-        foreach (ISingleObjectiveMoveEvaluator evaluator in problem.Operators.OfType<ISingleObjectiveMoveEvaluator>().OrderBy(x => x.Name))
-          MoveEvaluatorParameter.ValidValues.Add(evaluator);
-      }
-
-      if (oldMoveGenerator != null) {
-        IMoveGenerator newMoveGenerator = MoveGeneratorParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldMoveGenerator.GetType());
-        if (newMoveGenerator != null) MoveGenerator = newMoveGenerator;
-      }
-      if (MoveGenerator == null) {
-        ClearMoveParameters();
-      }
-
-      if (oldMoveMaker != null) {
-        IMoveMaker mm = MoveMakerParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldMoveMaker.GetType());
-        if (mm != null) MoveMaker = mm;
-      }
-
-      if (oldMoveEvaluator != null) {
-        ISingleObjectiveMoveEvaluator me = MoveEvaluatorParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldMoveEvaluator.GetType());
-        if (me != null) MoveEvaluator = me;
-      }
-    }
-
-    private void ChooseMoveOperators() {
-      IMoveMaker oldMoveMaker = MoveMaker;
-      ISingleObjectiveMoveEvaluator oldMoveEvaluator = MoveEvaluator;
-
-      if (MoveGenerator != null) {
-        List<Type> moveTypes = MoveGenerator.GetType().GetInterfaces().Where(x => typeof(IMoveOperator).IsAssignableFrom(x)).ToList();
-        foreach (Type type in moveTypes.ToList()) {
-          if (moveTypes.Any(t => t != type && type.IsAssignableFrom(t)))
-            moveTypes.Remove(type);
-        }
-        List<IMoveMaker> validMoveMakers = new List<IMoveMaker>();
-        List<ISingleObjectiveMoveEvaluator> validMoveEvaluators = new List<ISingleObjectiveMoveEvaluator>();
-
-        foreach (Type type in moveTypes) {
-          var moveMakers = MoveMakerParameter.ValidValues.Where(x => type.IsAssignableFrom(x.GetType())).OrderBy(x => x.Name);
-          foreach (IMoveMaker moveMaker in moveMakers)
-            validMoveMakers.Add(moveMaker);
-
-          var moveEvaluators = MoveEvaluatorParameter.ValidValues.Where(x => type.IsAssignableFrom(x.GetType())).OrderBy(x => x.Name);
-          foreach (ISingleObjectiveMoveEvaluator moveEvaluator in moveEvaluators)
-            validMoveEvaluators.Add(moveEvaluator);
-        }
-        if (oldMoveMaker != null) {
-          IMoveMaker mm = validMoveMakers.FirstOrDefault(x => x.GetType() == oldMoveMaker.GetType());
-          if (mm != null) MoveMaker = mm;
-          else MoveMaker = validMoveMakers.FirstOrDefault();
-        } 
-
-        if (oldMoveEvaluator != null) {
-          ISingleObjectiveMoveEvaluator me = validMoveEvaluators.FirstOrDefault(x => x.GetType() == oldMoveEvaluator.GetType());
-          if (me != null) MoveEvaluator = me;
-          else MoveEvaluator = validMoveEvaluators.FirstOrDefault();
-        } 
-      }
-    }
-
-    private void ClearMoveParameters() {
-      MoveGeneratorParameter.ValidValues.Clear();
-      MoveMakerParameter.ValidValues.Clear();
-      MoveEvaluatorParameter.ValidValues.Clear();
-    }
-
-    private void ParameterizeMoveGenerators(ISingleObjectiveProblem problem) {
-      if (problem != null) {
-        foreach (IMultiMoveGenerator generator in problem.Operators.OfType<IMultiMoveGenerator>())
-          generator.SampleSizeParameter.ActualName = SampleSizeParameter.Name;
-      }
-    }
-    private void ParameterizeMoveEvaluators(ISingleObjectiveProblem problem) {
-      foreach (ISingleObjectiveMoveEvaluator op in problem.Operators.OfType<ISingleObjectiveMoveEvaluator>()) {
-        op.QualityParameter.ActualName = problem.Evaluator.QualityParameter.ActualName;
-      }
-    }
-    private void ParameterizeMoveMakers(ISingleObjectiveProblem problem) {
-      foreach (IMoveMaker op in problem.Operators.OfType<IMoveMaker>()) {
-        op.QualityParameter.ActualName = problem.Evaluator.QualityParameter.ActualName;
-        if (MoveEvaluator != null)
-          op.MoveQualityParameter.ActualName = MoveEvaluator.MoveQualityParameter.ActualName;
-      }
-    }
-
-    public override IOperation Apply() {
-      Scope subScope = new Scope();
-      Scope individual = new Scope();
-
-      foreach (Variable var in ExecutionContext.Scope.Variables) {
-        individual.Variables.Add(var);
-      }
-      subScope.SubScopes.Add(individual);
-
-      ExecutionContext.Scope.SubScopes.Add(subScope);
-      int index = subScope.Parent.SubScopes.IndexOf(subScope);
-
-      SubScopesProcessor processor = new SubScopesProcessor();
-      SubScopesRemover remover = new SubScopesRemover();
-
-      remover.RemoveAllSubScopes = false;
-      remover.SubScopeIndexParameter.Value = new IntValue(index);
-
-      for (int i = 0; i < index; i++) {
-        processor.Operators.Add(new EmptyOperator());
-      }
-
-      loop.MoveGeneratorParameter.Value = MoveGeneratorParameter.Value;
-      if (loop.MoveGeneratorParameter.Value != null && loop.MoveGeneratorParameter.Value.Parameters.ContainsKey("SampleSize")) {
-        IParameter parameter = loop.MoveGeneratorParameter.Value.Parameters["SampleSize"];
-        if(parameter is IValueParameter)
-          (parameter as IValueParameter).Value = SampleSizeParameter.Value;
-      }
-      loop.MoveEvaluatorParameter.Value = MoveEvaluatorParameter.Value;
-      loop.MoveMakerParameter.Value = MoveMakerParameter.Value;
-      loop.MaximumIterationsParameter.Value = MaximumIterationsParameter.Value;
-      loop.EvaluatedMovesParameter.ActualName = EvaluatedSolutionsParameter.ActualName;
-      if (AnalyzerParameter.ActualValue != null) {
-        loop.AnalyzerParameter.Value = AnalyzerParameter.ActualValue.Clone() as IAnalyzer;
-
-        foreach (IScopeTreeLookupParameter param in loop.AnalyzerParameter.Value.Parameters.OfType<IScopeTreeLookupParameter>())
-          param.Depth = 0;
-
-        if (loop.AnalyzerParameter.Value is IMultiAnalyzer) {
-          foreach (IAnalyzer analyzer in (loop.AnalyzerParameter.Value as IMultiAnalyzer).Operators) {
-            foreach (IScopeTreeLookupParameter param in analyzer.Parameters.OfType<IScopeTreeLookupParameter>())
-              param.Depth = 0;
-          }
-        }
-      } else {
-        loop.AnalyzerParameter.Value = null;
-      }
-            
-      processor.Operators.Add(loop);
-      processor.Successor = remover;
-
-      IOperation next = base.Apply();
-      if (next as ExecutionContext != null) {
-        remover.Successor = (next as ExecutionContext).Operator;
-      }
-
-      return ExecutionContext.CreateOperation(processor);
-    }
-  }
-}
Index: branches/VNS/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearchImprovementOperator.cs
===================================================================
--- branches/VNS/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearchImprovementOperator.cs	(revision 5735)
+++ branches/VNS/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearchImprovementOperator.cs	(revision 5735)
@@ -0,0 +1,301 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Operators;
+using HeuristicLab.Common;
+using HeuristicLab.Parameters;
+using HeuristicLab.Algorithms.LocalSearch;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Operators;
+using HeuristicLab.Analysis;
+
+namespace HeuristicLab.Algorithms.LocalSearch {
+  /// <summary>
+  /// A local search improvement operator.
+  /// </summary>
+  [Item("LocalSearchImprovementOperator", "A local search improvement operator.")]
+  [StorableClass]
+  public class LocalSearchImprovementOperator: SingleSuccessorOperator, ILocalImprovementOperator {
+    [Storable]
+    private LocalSearchMainLoop loop;
+
+    [Storable]
+    private BestAverageWorstQualityAnalyzer qualityAnalyzer;
+    
+    private ConstrainedValueParameter<IMoveGenerator> MoveGeneratorParameter {
+      get { return (ConstrainedValueParameter<IMoveGenerator>)Parameters["MoveGenerator"]; }
+    }
+    private ConstrainedValueParameter<IMoveMaker> MoveMakerParameter {
+      get { return (ConstrainedValueParameter<IMoveMaker>)Parameters["MoveMaker"]; }
+    }
+    private ConstrainedValueParameter<ISingleObjectiveMoveEvaluator> MoveEvaluatorParameter {
+      get { return (ConstrainedValueParameter<ISingleObjectiveMoveEvaluator>)Parameters["MoveEvaluator"]; }
+    }
+    private ValueParameter<IntValue> MaximumIterationsParameter {
+      get { return (ValueParameter<IntValue>)Parameters["MaximumIterations"]; }
+    }
+    private ValueParameter<IntValue> SampleSizeParameter {
+      get { return (ValueParameter<IntValue>)Parameters["SampleSize"]; }
+    }
+    public LookupParameter<IntValue> EvaluatedSolutionsParameter {
+      get { return (LookupParameter<IntValue>)Parameters["EvaluatedSolutions"]; }
+    }
+    public ValueParameter<MultiAnalyzer> AnalyzerParameter {
+      get { return (ValueParameter<MultiAnalyzer>)Parameters["Analyzer"]; }
+    }
+
+    public IMoveGenerator MoveGenerator {
+      get { return MoveGeneratorParameter.Value; }
+      set { MoveGeneratorParameter.Value = value; }
+    }
+    public IMoveMaker MoveMaker {
+      get { return MoveMakerParameter.Value; }
+      set { MoveMakerParameter.Value = value; }
+    }
+    public ISingleObjectiveMoveEvaluator MoveEvaluator {
+      get { return MoveEvaluatorParameter.Value; }
+      set { MoveEvaluatorParameter.Value = value; }
+    }
+    public MultiAnalyzer Analyzer {
+      get { return AnalyzerParameter.Value; }
+      set { AnalyzerParameter.Value = value; }
+    }
+
+    [StorableConstructor]
+    protected LocalSearchImprovementOperator(bool deserializing) : base(deserializing) {}
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      Initialize();
+    }
+    protected LocalSearchImprovementOperator(LocalSearchImprovementOperator original, Cloner cloner)
+      : base(original, cloner) {
+        this.loop = cloner.Clone(original.loop);
+        this.qualityAnalyzer = cloner.Clone(original.qualityAnalyzer);
+        Initialize();
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new LocalSearchImprovementOperator(this, cloner);
+    }
+    public LocalSearchImprovementOperator()
+      : base() {
+        loop = new LocalSearchMainLoop("LocalIterations", "BestLocalQuality");
+
+        ResultsCollector rc = ((loop.OperatorGraph.InitialOperator as SingleSuccessorOperator).Successor 
+          as SingleSuccessorOperator).Successor as ResultsCollector;
+        rc.CollectedValues.Remove("BestLocalQuality");
+
+        qualityAnalyzer = new BestAverageWorstQualityAnalyzer();
+
+        Parameters.Add(new ConstrainedValueParameter<IMoveGenerator>("MoveGenerator", "The operator used to generate moves to the neighborhood of the current solution."));
+        Parameters.Add(new ConstrainedValueParameter<IMoveMaker>("MoveMaker", "The operator used to perform a move."));
+        Parameters.Add(new ConstrainedValueParameter<ISingleObjectiveMoveEvaluator>("MoveEvaluator", "The operator used to evaluate a move."));
+        Parameters.Add(new ValueParameter<IntValue>("MaximumIterations", "The maximum number of generations which should be processed.", new IntValue(150)));
+        Parameters.Add(new ValueParameter<IntValue>("SampleSize", "Number of moves that MultiMoveGenerators should create. This is ignored for Exhaustive- and SingleMoveGenerators.", new IntValue(1500)));
+        Parameters.Add(new LookupParameter<IntValue>("EvaluatedSolutions", "The number of evaluated moves."));
+        Parameters.Add(new ValueParameter<MultiAnalyzer>("Analyzer", "The operator used to analyze the solution.", new MultiAnalyzer()));
+
+        Initialize();
+    }
+
+    private void Initialize() {
+      MoveGeneratorParameter.ValueChanged += new EventHandler(MoveGeneratorParameter_ValueChanged);
+    }
+
+    public void OnProblemChanged(IProblem problem) {
+      UpdateMoveOperators(problem);
+      ChooseMoveOperators();
+
+      ParameterizeMoveGenerators(problem as ISingleObjectiveProblem);
+      ParameterizeMoveEvaluators(problem as ISingleObjectiveProblem);
+      ParameterizeMoveMakers(problem as ISingleObjectiveProblem);
+
+      ParameterizeAnalyzers(problem as ISingleObjectiveProblem);
+      UpdateAnalyzers(problem as ISingleObjectiveProblem);
+    }
+
+    void ParameterizeAnalyzers(ISingleObjectiveProblem problem) {
+      qualityAnalyzer.ResultsParameter.ActualName = "Results";
+      if (problem != null) {
+        qualityAnalyzer.MaximizationParameter.ActualName = problem.MaximizationParameter.Name;
+        if (MoveEvaluator != null)
+          qualityAnalyzer.QualityParameter.ActualName = MoveEvaluator.MoveQualityParameter.ActualName;
+        qualityAnalyzer.BestKnownQualityParameter.ActualName = problem.BestKnownQualityParameter.Name;
+      }
+    }
+
+    void UpdateAnalyzers(ISingleObjectiveProblem problem) {
+      Analyzer.Operators.Clear();
+      if (problem != null) {
+        foreach (IAnalyzer analyzer in problem.Operators.OfType<IAnalyzer>()) {
+          IAnalyzer clone = analyzer.Clone() as IAnalyzer;
+          foreach (IScopeTreeLookupParameter param in clone.Parameters.OfType<IScopeTreeLookupParameter>())
+            param.Depth = 0;
+          Analyzer.Operators.Add(clone);
+        }
+      }
+      Analyzer.Operators.Add(qualityAnalyzer);
+    }
+
+    void MoveGeneratorParameter_ValueChanged(object sender, EventArgs e) {
+      ChooseMoveOperators();
+    }
+
+    private void UpdateMoveOperators(IProblem problem) {
+      IMoveGenerator oldMoveGenerator = MoveGenerator;
+      IMoveMaker oldMoveMaker = MoveMaker;
+      ISingleObjectiveMoveEvaluator oldMoveEvaluator = MoveEvaluator;
+
+      ClearMoveParameters();
+
+      if (problem != null) {
+        foreach (IMoveGenerator generator in problem.Operators.OfType<IMoveGenerator>().OrderBy(x => x.Name))
+          MoveGeneratorParameter.ValidValues.Add(generator);
+
+        foreach (IMoveMaker maker in problem.Operators.OfType<IMoveMaker>().OrderBy(x => x.Name))
+          MoveMakerParameter.ValidValues.Add(maker);
+
+        foreach (ISingleObjectiveMoveEvaluator evaluator in problem.Operators.OfType<ISingleObjectiveMoveEvaluator>().OrderBy(x => x.Name))
+          MoveEvaluatorParameter.ValidValues.Add(evaluator);
+      }
+
+      if (oldMoveGenerator != null) {
+        IMoveGenerator newMoveGenerator = MoveGeneratorParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldMoveGenerator.GetType());
+        if (newMoveGenerator != null) MoveGenerator = newMoveGenerator;
+      }
+      if (MoveGenerator == null) {
+        ClearMoveParameters();
+      }
+
+      if (oldMoveMaker != null) {
+        IMoveMaker mm = MoveMakerParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldMoveMaker.GetType());
+        if (mm != null) MoveMaker = mm;
+      }
+
+      if (oldMoveEvaluator != null) {
+        ISingleObjectiveMoveEvaluator me = MoveEvaluatorParameter.ValidValues.FirstOrDefault(x => x.GetType() == oldMoveEvaluator.GetType());
+        if (me != null) MoveEvaluator = me;
+      }
+    }
+
+    private void ChooseMoveOperators() {
+      IMoveMaker oldMoveMaker = MoveMaker;
+      ISingleObjectiveMoveEvaluator oldMoveEvaluator = MoveEvaluator;
+
+      if (MoveGenerator != null) {
+        List<Type> moveTypes = MoveGenerator.GetType().GetInterfaces().Where(x => typeof(IMoveOperator).IsAssignableFrom(x)).ToList();
+        foreach (Type type in moveTypes.ToList()) {
+          if (moveTypes.Any(t => t != type && type.IsAssignableFrom(t)))
+            moveTypes.Remove(type);
+        }
+        List<IMoveMaker> validMoveMakers = new List<IMoveMaker>();
+        List<ISingleObjectiveMoveEvaluator> validMoveEvaluators = new List<ISingleObjectiveMoveEvaluator>();
+
+        foreach (Type type in moveTypes) {
+          var moveMakers = MoveMakerParameter.ValidValues.Where(x => type.IsAssignableFrom(x.GetType())).OrderBy(x => x.Name);
+          foreach (IMoveMaker moveMaker in moveMakers)
+            validMoveMakers.Add(moveMaker);
+
+          var moveEvaluators = MoveEvaluatorParameter.ValidValues.Where(x => type.IsAssignableFrom(x.GetType())).OrderBy(x => x.Name);
+          foreach (ISingleObjectiveMoveEvaluator moveEvaluator in moveEvaluators)
+            validMoveEvaluators.Add(moveEvaluator);
+        }
+        if (oldMoveMaker != null) {
+          IMoveMaker mm = validMoveMakers.FirstOrDefault(x => x.GetType() == oldMoveMaker.GetType());
+          if (mm != null) MoveMaker = mm;
+          else MoveMaker = validMoveMakers.FirstOrDefault();
+        } 
+
+        if (oldMoveEvaluator != null) {
+          ISingleObjectiveMoveEvaluator me = validMoveEvaluators.FirstOrDefault(x => x.GetType() == oldMoveEvaluator.GetType());
+          if (me != null) MoveEvaluator = me;
+          else MoveEvaluator = validMoveEvaluators.FirstOrDefault();
+        } 
+      }
+    }
+
+    private void ClearMoveParameters() {
+      MoveGeneratorParameter.ValidValues.Clear();
+      MoveMakerParameter.ValidValues.Clear();
+      MoveEvaluatorParameter.ValidValues.Clear();
+    }
+
+    private void ParameterizeMoveGenerators(ISingleObjectiveProblem problem) {
+      if (problem != null) {
+        foreach (IMultiMoveGenerator generator in problem.Operators.OfType<IMultiMoveGenerator>())
+          generator.SampleSizeParameter.ActualName = SampleSizeParameter.Name;
+      }
+    }
+    private void ParameterizeMoveEvaluators(ISingleObjectiveProblem problem) {
+      foreach (ISingleObjectiveMoveEvaluator op in problem.Operators.OfType<ISingleObjectiveMoveEvaluator>()) {
+        op.QualityParameter.ActualName = problem.Evaluator.QualityParameter.ActualName;
+      }
+    }
+    private void ParameterizeMoveMakers(ISingleObjectiveProblem problem) {
+      foreach (IMoveMaker op in problem.Operators.OfType<IMoveMaker>()) {
+        op.QualityParameter.ActualName = problem.Evaluator.QualityParameter.ActualName;
+        if (MoveEvaluator != null)
+          op.MoveQualityParameter.ActualName = MoveEvaluator.MoveQualityParameter.ActualName;
+      }
+    }
+
+    public override IOperation Apply() {
+      Scope subScope = new Scope();
+      Scope individual = new Scope();
+
+      foreach (Variable var in ExecutionContext.Scope.Variables) {
+        individual.Variables.Add(var);
+      }
+      subScope.SubScopes.Add(individual);
+
+      ExecutionContext.Scope.SubScopes.Add(subScope);
+      int index = subScope.Parent.SubScopes.IndexOf(subScope);
+
+      SubScopesProcessor processor = new SubScopesProcessor();
+      SubScopesRemover remover = new SubScopesRemover();
+
+      remover.RemoveAllSubScopes = false;
+      remover.SubScopeIndexParameter.Value = new IntValue(index);
+
+      for (int i = 0; i < index; i++) {
+        processor.Operators.Add(new EmptyOperator());
+      }
+
+      loop.EvaluatedMovesParameter.ActualName = EvaluatedSolutionsParameter.ActualName;
+
+      processor.Operators.Add(loop);
+      processor.Successor = remover;
+
+      IOperation next = base.Apply();
+      if (next as ExecutionContext != null) {
+        remover.Successor = (next as ExecutionContext).Operator;
+      }
+
+      return ExecutionContext.CreateChildOperation(processor);
+    }
+  }
+}
Index: branches/VNS/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearchMainLoop.cs
===================================================================
--- branches/VNS/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearchMainLoop.cs	(revision 5642)
+++ branches/VNS/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearchMainLoop.cs	(revision 5735)
@@ -77,11 +77,11 @@
     [StorableConstructor]
     private LocalSearchMainLoop(bool deserializing) : base(deserializing) { }
+    public LocalSearchMainLoop(string iterationsName, string bestQualityName)
+      : base() {
+        Initialize(iterationsName, bestQualityName);
+    }
     public LocalSearchMainLoop()
       : base() {
-      Initialize(false);
-    }
-    public LocalSearchMainLoop(BoolValue nested)
-      : base() {
-      Initialize(nested.Value);
+      Initialize("Iterations", "BestQuality");
     }
     private LocalSearchMainLoop(LocalSearchMainLoop original, Cloner cloner)
@@ -92,9 +92,10 @@
     }
 
-    private void Initialize(bool nested) {
+    private void Initialize(string iterationsName, string bestQualityName) {
       #region Create parameters
       Parameters.Add(new ValueLookupParameter<IRandom>("Random", "A pseudo random number generator."));
       Parameters.Add(new ValueLookupParameter<BoolValue>("Maximization", "True if the problem is a maximization problem, otherwise false."));
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The value which represents the quality of a solution."));
+      Parameters.Add(new LookupParameter<DoubleValue>("BestQuality", "The value which represents the best quality fjo."));
       Parameters.Add(new ValueLookupParameter<DoubleValue>("BestKnownQuality", "The best known quality value found so far."));
       Parameters.Add(new LookupParameter<DoubleValue>("MoveQuality", "The value which represents the quality of a move."));
@@ -128,4 +129,5 @@
       Placeholder moveMaker = new Placeholder();
       Assigner bestQualityUpdater = new Assigner();
+      ResultsCollector resultsCollector2 = new ResultsCollector();
       MergingReducer mergingReducer = new MergingReducer();
       Placeholder analyzer2 = new Placeholder();
@@ -135,11 +137,9 @@
       ConditionalBranch iterationsTermination = new ConditionalBranch();
 
-      variableCreator.CollectedValues.Add(new ValueParameter<IntValue>("Iterations", new IntValue(0))); // Class LocalSearch expects this to be called Iterations
-      if (!nested) {
-        variableCreator.CollectedValues.Add(new ValueParameter<DoubleValue>("BestQuality", new DoubleValue(0)));
-      }
+      variableCreator.CollectedValues.Add(new ValueParameter<IntValue>(iterationsName, new IntValue(0))); // Class LocalSearch expects this to be called Iterations
+      variableCreator.CollectedValues.Add(new ValueParameter<DoubleValue>(bestQualityName, new DoubleValue(0)));
 
       bestQualityInitializer.Name = "Initialize BestQuality";
-      bestQualityInitializer.LeftSideParameter.ActualName = "BestQuality";
+      bestQualityInitializer.LeftSideParameter.ActualName = bestQualityName;
       bestQualityInitializer.RightSideParameter.ActualName = QualityParameter.Name;
 
@@ -148,8 +148,6 @@
 
       resultsCollector1.CopyValue = new BoolValue(false);
-      resultsCollector1.CollectedValues.Add(new LookupParameter<IntValue>("Iterations"));
-      if (!nested) {
-        resultsCollector1.CollectedValues.Add(new LookupParameter<DoubleValue>("Best Quality", null, "BestQuality"));
-      }
+      resultsCollector1.CollectedValues.Add(new LookupParameter<IntValue>(iterationsName));
+      resultsCollector1.CollectedValues.Add(new LookupParameter<DoubleValue>(bestQualityName, null, bestQualityName));
       resultsCollector1.ResultsParameter.ActualName = ResultsParameter.Name;
 
@@ -180,6 +178,10 @@
 
       bestQualityUpdater.Name = "Update BestQuality";
-      bestQualityUpdater.LeftSideParameter.ActualName = "BestQuality";
+      bestQualityUpdater.LeftSideParameter.ActualName = bestQualityName;
       bestQualityUpdater.RightSideParameter.ActualName = QualityParameter.Name;
+
+      resultsCollector2.CopyValue = new BoolValue(false);
+      resultsCollector2.CollectedValues.Add(new LookupParameter<DoubleValue>(bestQualityName, null, bestQualityName));
+      resultsCollector2.ResultsParameter.ActualName = ResultsParameter.Name;
 
       analyzer2.Name = "Analyzer (placeholder)";
@@ -190,9 +192,9 @@
       iterationsCounter.Name = "Iterations Counter";
       iterationsCounter.Increment = new IntValue(1);
-      iterationsCounter.ValueParameter.ActualName = "Iterations";
+      iterationsCounter.ValueParameter.ActualName = iterationsName;
 
       iterationsComparator.Name = "Iterations >= MaximumIterations";
       iterationsComparator.Comparison = new Comparison(ComparisonType.GreaterOrEqual);
-      iterationsComparator.LeftSideParameter.ActualName = "Iterations";
+      iterationsComparator.LeftSideParameter.ActualName = iterationsName;
       iterationsComparator.RightSideParameter.ActualName = MaximumIterationsParameter.Name;
       iterationsComparator.ResultParameter.ActualName = "Terminate";
@@ -205,9 +207,5 @@
       OperatorGraph.InitialOperator = variableCreator;
       variableCreator.Successor = subScopesProcessor0;
-      if (!nested) {
-        subScopesProcessor0.Operators.Add(bestQualityInitializer);
-      } else {
-        subScopesProcessor0.Operators.Add(analyzer1);
-      }
+      subScopesProcessor0.Operators.Add(bestQualityInitializer);
       subScopesProcessor0.Successor = resultsCollector1;
       bestQualityInitializer.Successor = analyzer1;
@@ -230,9 +228,5 @@
       improvesQualityBranch.FalseBranch = null;
       improvesQualityBranch.Successor = null;
-      if (!nested) {
-        moveMaker.Successor = bestQualityUpdater;
-      } else {
-        moveMaker.Successor = null; 
-      }
+      moveMaker.Successor = bestQualityUpdater;
       bestQualityUpdater.Successor = null;
       mergingReducer.Successor = analyzer2;
Index: branches/VNS/HeuristicLab.Algorithms.VariableNeighborhoodSearch/3.3/VariableNeighborhoodSearch.cs
===================================================================
--- branches/VNS/HeuristicLab.Algorithms.VariableNeighborhoodSearch/3.3/VariableNeighborhoodSearch.cs	(revision 5642)
+++ branches/VNS/HeuristicLab.Algorithms.VariableNeighborhoodSearch/3.3/VariableNeighborhoodSearch.cs	(revision 5735)
@@ -39,6 +39,6 @@
       get { return (ValueParameter<BoolValue>)Parameters["SetSeedRandomly"]; }
     }
-    private ValueParameter<ILocalImprovement> LocalImprovementParameter {
-      get { return (ValueParameter<ILocalImprovement>)Parameters["LocalImprovement"]; }
+    private ValueParameter<ILocalImprovementOperator> LocalImprovementParameter {
+      get { return (ValueParameter<ILocalImprovementOperator>)Parameters["LocalImprovement"]; }
     }
     private ValueParameter<IShakingOperator> ShakingParameter {
@@ -90,5 +90,5 @@
       Parameters.Add(new ValueParameter<IntValue>("Seed", "The random seed used to initialize the new pseudo random number generator.", new IntValue(0)));
       Parameters.Add(new ValueParameter<BoolValue>("SetSeedRandomly", "True if the random seed should be set to a random value, otherwise false.", new BoolValue(true)));
-      Parameters.Add(new ValueParameter<ILocalImprovement>("LocalImprovement", "The local improvement operation", new LocalSearchImprovement()));
+      Parameters.Add(new ValueParameter<ILocalImprovementOperator>("LocalImprovement", "The local improvement operation", new LocalSearchImprovementOperator()));
       Parameters.Add(new ValueParameter<IShakingOperator>("Shaking", "The shaking operation"));
       Parameters.Add(new ValueParameter<IntValue>("MaximumIterations", "The maximum number of generations which should be processed.", new IntValue(1000)));
@@ -215,5 +215,5 @@
       if (Problem != null) {
         foreach (IIterationBasedOperator op in Problem.Operators.OfType<IIterationBasedOperator>()) {
-          op.IterationsParameter.ActualName = "OuterIterations";
+          op.IterationsParameter.ActualName = "Iterations";
           op.MaximumIterationsParameter.ActualName = "MaximumIterations";
         }
@@ -267,5 +267,5 @@
     }
     private void UpdateLocalImprovementOperator() {
-      LocalImprovementParameter.Value.Parameterize(Problem);
+      LocalImprovementParameter.Value.OnProblemChanged(Problem);
     }
     private void UpdateAnalyzers() {
Index: branches/VNS/HeuristicLab.Algorithms.VariableNeighborhoodSearch/3.3/VariableNeighborhoodSearchMainLoop.cs
===================================================================
--- branches/VNS/HeuristicLab.Algorithms.VariableNeighborhoodSearch/3.3/VariableNeighborhoodSearchMainLoop.cs	(revision 5642)
+++ branches/VNS/HeuristicLab.Algorithms.VariableNeighborhoodSearch/3.3/VariableNeighborhoodSearchMainLoop.cs	(revision 5735)
@@ -69,6 +69,6 @@
       get { return (LookupParameter<IntValue>)Parameters["EvaluatedSolutions"]; }
     }
-    public ValueLookupParameter<ILocalImprovement> LocalImprovementParameter {
-      get { return (ValueLookupParameter<ILocalImprovement>)Parameters["LocalImprovement"]; }
+    public ValueLookupParameter<ILocalImprovementOperator> LocalImprovementParameter {
+      get { return (ValueLookupParameter<ILocalImprovementOperator>)Parameters["LocalImprovement"]; }
     }
     public ValueLookupParameter<IShakingOperator> ShakingParameter {
@@ -102,5 +102,5 @@
       Parameters.Add(new ValueLookupParameter<IOperator>("Analyzer", "The operator used to analyze the solution."));
       Parameters.Add(new LookupParameter<IntValue>("EvaluatedSolutions", "The number of evaluated solutions."));
-      Parameters.Add(new ValueLookupParameter<ILocalImprovement>("LocalImprovement", "The local improvement operation."));
+      Parameters.Add(new ValueLookupParameter<ILocalImprovementOperator>("LocalImprovement", "The local improvement operation."));
       Parameters.Add(new ValueLookupParameter<IShakingOperator>("Shaking", "The shaking operation."));
       #endregion
@@ -116,7 +116,6 @@
       Assigner iterationInit = new Assigner();
 
-      ChildrenCreator createChild = new ChildrenCreator();
+      SubScopesCloner createChild = new SubScopesCloner();
       SubScopesProcessor childProcessor = new SubScopesProcessor();
-      ParentCopyCrossover parentCloner = new ParentCopyCrossover();
 
       Assigner qualityAssigner = new Assigner();
@@ -127,16 +126,15 @@
 
       QualityComparator qualityComparator = new QualityComparator();
-      ConditionalBranch improvesQualityBranch = new ConditionalBranch();
+      ConditionalBranch improvesQualityBranch1 = new ConditionalBranch();
       ConditionalBranch improvesQualityBranch2 = new ConditionalBranch();
 
       Assigner bestQualityUpdater = new Assigner();
-      ScopeCleaner cleaner = new ScopeCleaner();
-      ParentCopyCrossover originalRestorer = new ParentCopyCrossover();
+
+      BestSelector bestSelector = new BestSelector();
+      RightReducer rightReducer = new RightReducer();
 
       IntCounter indexCounter = new IntCounter();
       Assigner indexResetter = new Assigner();
 
-      SubScopesRemover remover1 = new SubScopesRemover();
-      SubScopesRemover remover2 = new SubScopesRemover();
       Placeholder analyzer2 = new Placeholder();
 
@@ -147,5 +145,5 @@
       ConditionalBranch iterationsTermination = new ConditionalBranch();
 
-      variableCreator.CollectedValues.Add(new ValueParameter<IntValue>("OuterIterations", new IntValue(0)));
+      variableCreator.CollectedValues.Add(new ValueParameter<IntValue>("Iterations", new IntValue(0)));
       variableCreator.CollectedValues.Add(new ValueParameter<IntValue>("Index", new IntValue(0)));
       variableCreator.CollectedValues.Add(new ValueParameter<BoolValue>("Continue", new BoolValue(false)));
@@ -161,5 +159,5 @@
 
       resultsCollector1.CopyValue = new BoolValue(false);
-      resultsCollector1.CollectedValues.Add(new LookupParameter<IntValue>("OuterIterations"));
+      resultsCollector1.CollectedValues.Add(new LookupParameter<IntValue>("Iterations"));
       resultsCollector1.CollectedValues.Add(new LookupParameter<DoubleValue>("Best Quality", null, "BestQuality"));
       resultsCollector1.ResultsParameter.ActualName = ResultsParameter.Name;
@@ -172,7 +170,4 @@
 
       createChild.Name = "Create child";
-      createChild.ParentsPerChild.Value = 1;
-
-      parentCloner.Name = "Copy parent";
 
       qualityAssigner.Name = "Assign quality";
@@ -189,5 +184,5 @@
       evaluator.OperatorParameter.ActualName = EvaluatorParameter.Name;
 
-      evalCounter.Name = "Count evaluateions";
+      evalCounter.Name = "Count evaluations";
       evalCounter.Increment.Value = 1;
       evalCounter.ValueParameter.ActualName = EvaluatedSolutionsParameter.ActualName;
@@ -197,5 +192,5 @@
       qualityComparator.ResultParameter.ActualName = "IsBetter";
 
-      improvesQualityBranch.ConditionParameter.ActualName = "IsBetter";
+      improvesQualityBranch1.ConditionParameter.ActualName = "IsBetter";
       improvesQualityBranch2.ConditionParameter.ActualName = "IsBetter";
 
@@ -204,7 +199,8 @@
       bestQualityUpdater.RightSideParameter.ActualName = QualityParameter.Name;
 
-      cleaner.Name = "Clean scope";
-      cleaner.ClearSubScopesParameter.Value = new BoolValue(false);
-      originalRestorer.Name = "Restore original solution";
+      bestSelector.CopySelected = new BoolValue(false);
+      bestSelector.MaximizationParameter.ActualName = MaximizationParameter.Name;
+      bestSelector.NumberOfSelectedSubScopesParameter.Value = new IntValue(1);
+      bestSelector.QualityParameter.ActualName = QualityParameter.Name;
 
       indexCounter.Name = "Count index";
@@ -216,18 +212,14 @@
       indexResetter.RightSideParameter.Value = new IntValue(0);
 
-      remover1.Name = remover2.Name = "Remove subscope";
-
       analyzer2.Name = "Analyzer (placeholder)";
       analyzer2.OperatorParameter.ActualName = AnalyzerParameter.Name;
 
-      originalRestorer.Name = "Restore parent";
-
       iterationsCounter.Name = "Iterations Counter";
       iterationsCounter.Increment = new IntValue(1);
-      iterationsCounter.ValueParameter.ActualName = "OuterIterations";
+      iterationsCounter.ValueParameter.ActualName = "Iterations";
 
       iterationsComparator.Name = "Iterations >= MaximumIterations";
       iterationsComparator.Comparison = new Comparison(ComparisonType.GreaterOrEqual);
-      iterationsComparator.LeftSideParameter.ActualName = "OuterIterations";
+      iterationsComparator.LeftSideParameter.ActualName = "Iterations";
       iterationsComparator.RightSideParameter.ActualName = MaximumIterationsParameter.Name;
       iterationsComparator.ResultParameter.ActualName = "Terminate";
@@ -254,8 +246,8 @@
 
       createChild.Successor = childProcessor;
-      childProcessor.Operators.Add(parentCloner);
-      childProcessor.Successor = analyzer2;
+      childProcessor.Operators.Add(new EmptyOperator());
+      childProcessor.Operators.Add(qualityAssigner);
+      childProcessor.Successor = bestSelector;
       /////////
-      parentCloner.Successor = qualityAssigner;
       qualityAssigner.Successor = shaking;
       shaking.Successor = evaluator;
@@ -263,15 +255,15 @@
       evalCounter.Successor = localImprovement;
       localImprovement.Successor = qualityComparator;
-      qualityComparator.Successor = improvesQualityBranch;
-      improvesQualityBranch.TrueBranch = bestQualityUpdater;
-      improvesQualityBranch.FalseBranch = cleaner;
+      qualityComparator.Successor = improvesQualityBranch1;
+      improvesQualityBranch1.TrueBranch = bestQualityUpdater;
+      improvesQualityBranch1.FalseBranch = indexCounter;
 
       bestQualityUpdater.Successor = indexResetter;
-      indexResetter.Successor = remover1;
-
-      cleaner.Successor = originalRestorer;
-      originalRestorer.Successor = remover2;
-      remover2.Successor = indexCounter;
+      indexResetter.Successor = null;
+
+      indexCounter.Successor = null;
       /////////
+      bestSelector.Successor = rightReducer;
+      rightReducer.Successor = analyzer2;
       analyzer2.Successor = indexTermination;
       indexTermination.TrueBranch = improvesQualityBranch2;
Index: branches/VNS/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj
===================================================================
--- branches/VNS/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 5642)
+++ branches/VNS/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 5735)
@@ -124,4 +124,5 @@
       <SubType>Code</SubType>
     </Compile>
+    <Compile Include="SubScopesCloner.cs" />
     <Compile Include="SubScopesCounter.cs" />
     <Compile Include="SubScopesCreator.cs" />
Index: branches/VNS/HeuristicLab.Operators/3.3/ScopeCleaner.cs
===================================================================
--- branches/VNS/HeuristicLab.Operators/3.3/ScopeCleaner.cs	(revision 5642)
+++ branches/VNS/HeuristicLab.Operators/3.3/ScopeCleaner.cs	(revision 5735)
@@ -39,16 +39,4 @@
       get { return CurrentScopeParameter.ActualValue; }
     }
-    public ValueParameter<BoolValue> ClearSubScopesParameter {
-      get { return (ValueParameter<BoolValue>)Parameters["ClearSubScopes"]; }
-    }
-
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserializationHook() {
-      #region Backwards Compatibility
-      if (!Parameters.ContainsKey("ClearSubScopes")) {
-        Parameters.Add(new ValueParameter<BoolValue>("ClearSubScopes", "Indicates, if the subscopes should be cleared.", new BoolValue(false)));
-      }
-      #endregion
-    }
 
     [StorableConstructor]
@@ -58,7 +46,6 @@
     }
     public ScopeCleaner()
-      : base() {
+      : base() { 
       Parameters.Add(new ScopeParameter("CurrentScope", "The current scope whose variables and sub-scopes should be removed."));
-      Parameters.Add(new ValueParameter<BoolValue>("ClearSubScopes", "Indicates, if the subscopes should be cleared.", new BoolValue(false)));
     }
 
@@ -69,6 +56,5 @@
     public override IOperation Apply() {
       CurrentScope.Variables.Clear();
-      if(ClearSubScopesParameter.Value.Value)
-        CurrentScope.SubScopes.Clear();
+      CurrentScope.SubScopes.Clear();
       return base.Apply();
     }
Index: branches/VNS/HeuristicLab.Operators/3.3/SubScopesCloner.cs
===================================================================
--- branches/VNS/HeuristicLab.Operators/3.3/SubScopesCloner.cs	(revision 5735)
+++ branches/VNS/HeuristicLab.Operators/3.3/SubScopesCloner.cs	(revision 5735)
@@ -0,0 +1,82 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Operators {
+  /// <summary>
+  /// An operator which creates multiple copies of the subscopes of the current scope.
+  /// </summary>
+  [Item("SubScopesCloner", "An operator which creates multiple copies of the subscopes of the current scope.")]
+  [StorableClass]
+  public class SubScopesCloner : SingleSuccessorOperator {
+    private ScopeParameter CurrentScopeParameter {
+      get { return (ScopeParameter)Parameters["CurrentScope"]; }
+    }
+    private ValueParameter<IntValue> NumberOfCopiesParameter {
+      get { return (ValueParameter<IntValue>)Parameters["NumberOfCopies"]; }
+    }
+
+    public IScope CurrentScope {
+      get { return CurrentScopeParameter.ActualValue; }
+    }
+    public IntValue NumberOfCopies {
+      get { return NumberOfCopiesParameter.Value; }
+      set { NumberOfCopiesParameter.Value = value;  }
+    }
+
+
+    [StorableConstructor]
+    private SubScopesCloner(bool deserializing) : base(deserializing) { }
+    private SubScopesCloner(SubScopesCloner original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public SubScopesCloner()
+      : base() { 
+      Parameters.Add(new ScopeParameter("CurrentScope", "The current scope whose sub-scopes should be cloned."));
+      Parameters.Add(new ValueParameter<IntValue>("NumberOfCopies", "The number of copies that should be created.", new IntValue(1)));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SubScopesCloner(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      ScopeList subScopes = new ScopeList(CurrentScope.SubScopes);
+
+      for (int i = 0; i < NumberOfCopies.Value; i++) {
+        foreach (Scope scope in subScopes) {
+          CurrentScope.SubScopes.Add(scope.Clone() as IScope);
+        }
+      }
+
+       return base.Apply();
+    }
+  }
+}
Index: branches/VNS/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj
===================================================================
--- branches/VNS/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 5642)
+++ branches/VNS/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 5735)
@@ -116,5 +116,5 @@
     <Compile Include="Interfaces\IDiscreteDoubleMatrixModifier.cs" />
     <Compile Include="Interfaces\IGlobalParticleUpdater.cs" />
-    <Compile Include="Interfaces\ILocalImprovement.cs" />
+    <Compile Include="Interfaces\ILocalImprovementOperator.cs" />
     <Compile Include="Interfaces\ILocalParticleUpdater.cs" />
     <Compile Include="Interfaces\IMultiAnalyzer.cs" />
Index: branches/VNS/HeuristicLab.Optimization/3.3/Interfaces/ILocalImprovement.cs
===================================================================
--- branches/VNS/HeuristicLab.Optimization/3.3/Interfaces/ILocalImprovement.cs	(revision 5642)
+++ 	(revision )
@@ -1,33 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Core;
-using HeuristicLab.Optimization;
-
-namespace HeuristicLab.Optimization {
-  public interface ILocalImprovement: IOperator {
-    void Parameterize(IProblem problem);
-  }
-}
Index: branches/VNS/HeuristicLab.Optimization/3.3/Interfaces/ILocalImprovementOperator.cs
===================================================================
--- branches/VNS/HeuristicLab.Optimization/3.3/Interfaces/ILocalImprovementOperator.cs	(revision 5735)
+++ branches/VNS/HeuristicLab.Optimization/3.3/Interfaces/ILocalImprovementOperator.cs	(revision 5735)
@@ -0,0 +1,33 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Optimization {
+  public interface ILocalImprovementOperator: IOperator {
+    void OnProblemChanged(IProblem problem);
+  }
+}
